'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _extends = require('babel-runtime/helpers/extends')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _OptionJs = require('./Option.js');

var _OptionJs2 = _interopRequireDefault(_OptionJs);

var Select = (function (_Component) {
    _inherits(Select, _Component);

    function Select(props) {
        _classCallCheck(this, Select);

        _Component.call(this, props);
        this.loadData = [];
        this.focus = -1;
        this.state = {
            data: [],
            open: false,
            type: props.type,
            selected: this.props.selected,
            selectedData: [],
            openSearch: this.props.openSearch
        };
    }

    Select.prototype.componentWillMount = function componentWillMount() {
        var _this = this;

        var children = [],
            loadData = [],
            value = [],
            text = [];
        this.loadData = [];
        if (this.props.children) {
            if (this.props.children instanceof Array) {
                this.props.children.map(function (item) {
                    if (item instanceof Array) {
                        children = children.concat(item);
                    } else {
                        children.push(item);
                    }
                });
            } else {
                children.push(this.props.children);
            }
            children.forEach(function (item, index) {
                _this.loadData.push({
                    value: item.props.value,
                    text: item.props.children
                });
            });

            loadData = this.loadData;

            if (this.props.selected && this.props.selected.length > 0) {
                this.props.selected.map(function (item) {
                    text.push(loadData[item].text);
                    value.push(loadData[item]);
                });
            }
        }

        this.setState(_extends({}, this.state, {
            text: text,
            data: loadData,
            selectedData: value
        }));
    };

    Select.prototype.componentDidMount = function componentDidMount() {
        var _this2 = this;

        window.addEventListener('click', function (event) {
            _this2.globalMouseClick(event);
        });

        this.refs.myselect.getElementsByClassName('myselect-body-scroll').scrollTop = 0;
    };

    Select.prototype.componentWillUnmount = function componentWillUnmount() {
        window.removeEventListener('click', this.globalMouseClick);
    };

    Select.prototype._generateHead = function _generateHead() {
        var _this3 = this;

        var text = this.state.text;

        var searchInput = function searchInput(innerText) {
            return _react2['default'].createElement('input', { type: 'text', className: 'search-input', value: innerText, title: innerText, onClick: _this3.onHandClick.bind(_this3), onChange: _this3.onHandChange.bind(_this3) });
        };

        var innerText = function innerText() {
            if (_this3.props.type == 'single') {
                return searchInput(text);
            } else if (_this3.props.type == 'multiple') {
                return text && text instanceof Array ? text.map(function (item, index) {
                    return _react2['default'].createElement(
                        'div',
                        { key: index, className: 'multipleItem' },
                        _react2['default'].createElement(
                            'span',
                            { className: 'Select-value-icon', onClick: _this3.removeItem.bind(_this3, index) },
                            '×'
                        ),
                        _react2['default'].createElement(
                            'span',
                            { className: 'Select-value-label', onClick: _this3.onHandClick.bind(_this3), title: item },
                            item
                        )
                    );
                }) : _react2['default'].createElement(
                    'span',
                    null,
                    text
                );
            }
        };

        return _react2['default'].createElement(
            'div',
            { onClick: function () {
                    return _this3.toggleMenu();
                } },
            _react2['default'].createElement(
                'div',
                { className: 'myselect-head' },
                _react2['default'].createElement(
                    'div',
                    { className: 'items', ref: 'multipleItem' },
                    innerText()
                ),
                _react2['default'].createElement(
                    'div',
                    { className: 'dropdown-toggle' },
                    _react2['default'].createElement('i', null)
                )
            )
        );
    };

    Select.prototype._generateBody = function _generateBody() {
        var _this4 = this;

        var body = '';
        if (Array.isArray(this.state.data)) {
            body = this.state.data.map((function (item, i) {
                var selected = false;

                var focused = false;
                this.focus == i ? focused = true : '';

                typeof this.state.selected == 'object' ? this.state.selected.map(function (item) {
                    item == i ? selected = true : '';
                }) : '';

                return _react2['default'].createElement(
                    'div',
                    { key: i },
                    _react2['default'].createElement(_OptionJs2['default'], { item: item, selected: selected, index: i, focused: focused, hasIcon: this.props.hasIcon,
                        type: this.state.type,
                        selectItem: this.selectItem.bind(this),
                        focusItem: this.focusItem.bind(this)
                    })
                );
            }).bind(this));
        }

        var _renderBody = function _renderBody() {
            if (_this4.props.type == "single" && _this4.props.openSearch) {
                return body && body.length > 0 ? body : _react2['default'].createElement(
                    'div',
                    { className: 'no-data' },
                    _react2['default'].createElement(
                        'div',
                        { className: 'text' },
                        _this4.props.noSearchDataTips
                    )
                );
            } else {
                return body && body.length > 0 ? body : null;
            }
        };

        return _react2['default'].createElement(
            'div',
            null,
            _react2['default'].createElement(
                'div',
                { className: 'myselect-body', style: { maxHeight: this.props.maxHeight } },
                _react2['default'].createElement(
                    'div',
                    { className: 'myselect-body-scroll' },
                    _renderBody()
                )
            )
        );
    };

    Select.prototype.onHandChange = function onHandChange(e) {
        e.stopPropagation();
        if (this.props.openSearch) {
            this.filterBySearch();
        }
    };

    Select.prototype.onHandClick = function onHandClick() {
        if (!this.state.open) {
            this.setState(_extends({}, this.state, {
                open: true
            }));
        }
    };

    Select.prototype.focusItem = function focusItem(focus) {
        this.focus = focus;
    };

    Select.prototype.filterBySearch = function filterBySearch() {
        var _this5 = this;

        var filter = this.refs.myselect.getElementsByClassName('search-input')[0].value;

        var data = [];
        var selected = [];
        for (var i in this.loadData) {
            if (this.loadData[i].text.toString().toLowerCase().indexOf(filter.toLowerCase()) > -1) {
                data.push(this.loadData[i]);
            }
        }
        // 重新匹配是否有选中
        data.map(function (item, index) {
            if (_this5.state.selectedData && _this5.state.selectedData.length > 0) {
                if (_this5.state.selectedData[0].value === item.value) {
                    return selected.push(index);
                }
            }
        });
        this.setState(_extends({}, this.state, {
            text: [filter],
            data: data,
            selected: selected
        }));
    };

    Select.prototype.toggleMenu = function toggleMenu() {
        var myselect = this.refs.myselect;

        this.setState(_extends({}, this.state, {
            open: !this.state.open
        }));
    };

    Select.prototype.selectItem = function selectItem(item) {
        var _this6 = this;

        var text = undefined,
            value = undefined;
        if (item) {
            if (item.length > 0) {
                text = [];
                value = [];
                for (var i in item) {
                    text.push(item[i].text);
                    value.push(item[i].value);
                }
            } else {
                text = item.text;
                value = item.value;
            }

            if (this.state.type == 'single') {

                this.setState({ text: text, selected: [this.focus], selectedData: [item] }, function () {
                    _this6.toggleMenu();
                    _this6.props.onSelected ? _this6.props.onSelected(item) : '';
                });
            } else if (this.state.type == 'multiple') {

                if (typeof this.state.text == 'string') {
                    this.setState({
                        text: [text],
                        selected: [this.focus],
                        selectedData: [item]
                    }, function () {
                        _this6.props.onSelected ? _this6.props.onSelected(item) : '';
                    });
                } else {
                    (function () {

                        var splice = undefined;

                        _this6.state.text.map(function (textItem, i) {
                            if (text == textItem) {
                                splice = i;
                            }
                        });

                        var texts = _this6.state.text;
                        var selected = _this6.state.selected;
                        var selectedData = _this6.state.selectedData;

                        if (splice || splice == 0) {
                            texts.splice(splice, 1);
                            selected.splice(splice, 1);
                            selectedData.splice(splice, 1);
                        } else {
                            texts.push(text);
                            selected.push(_this6.focus);
                            selectedData.push(item);
                        }

                        _this6.setState({
                            text: texts,
                            selected: selected,
                            selectedData: selectedData
                        }, function () {
                            _this6.props.onSelected ? _this6.props.onSelected(selectedData) : '';
                        });
                    })();
                }
            }
        }
    };

    Select.prototype.removeItem = function removeItem(index, e) {
        var _this7 = this;

        e.stopPropagation();

        var texts = this.state.text;
        var selected = this.state.selected;
        var selectedData = this.state.selectedData;

        if (index || index == 0) {
            texts.splice(index, 1);
            selected.splice(index, 1);
            selectedData.splice(index, 1);
        }
        this.setState(_extends({}, this.state, {
            text: texts,
            selected: selected,
            selectedData: selectedData
        }), function () {
            _this7.props.onSelected ? _this7.props.onSelected(selectedData) : '';
        });
    };

    Select.prototype.globalMouseClick = function globalMouseClick(event) {
        var _this8 = this;

        var target = event.target;

        var i = 0;
        var hideMenu = true;

        while (this.checkParentElement(target) && i < 10) {
            target = target.parentElement;
            i++;
            if (target.innerHTML == this.refs.myselect.innerHTML) {
                hideMenu = false;
            }
        }

        if (hideMenu && target.className != 'myselect-item' && target.className != 'myselect-item selected') {
            if (this.props.openSearch && this.props.type == "single") {
                (function () {
                    var selected = [];
                    if (_this8.state.selectedData && _this8.state.selectedData.length > 0) {
                        var text = _this8.state.selectedData[0].text;
                        _this8.loadData.map(function (item, index) {
                            if (_this8.state.selectedData[0].value === item.value) {
                                return selected.push(index);
                            }
                        });
                        _this8.setState(_extends({}, _this8.state, {
                            text: [text],
                            data: _this8.loadData,
                            selected: selected,
                            open: false
                        }));
                    } else {
                        _this8.setState(_extends({}, _this8.state, {
                            open: false
                        }));
                    }
                })();
            } else {
                this.setState(_extends({}, this.state, {
                    open: false
                }));
            }
        }
    };

    Select.prototype.checkParentElement = function checkParentElement(target) {
        if (target.parentElement != null) {
            return true;
        } else {
            return false;
        }
    };

    Select.prototype.render = function render() {

        var head = this._generateHead();
        var body = this._generateBody();

        return _react2['default'].createElement(
            'div',
            _extends({ ref: 'myselect', className: 'myselect' }, this.props, { style: { width: this.props.width } }),
            head,
            _react2['default'].createElement(
                'div',
                { style: this.state.open && !this.props.disabled ? {} : { display: 'none' } },
                body
            )
        );
    };

    return Select;
})(_react.Component);

Select.propTypes = {
    maxHeight: _react2['default'].PropTypes.number,
    /*
        * 宽度
    */
    width: _react2['default'].PropTypes.number,
    text: _react2['default'].PropTypes.any,
    openSearch: _react2['default'].PropTypes.bool,
    type: _react2['default'].PropTypes.oneOf(["single", "multiple"]),
    onSelected: _react2['default'].PropTypes.func,
    selected: _react2['default'].PropTypes.array,
    value: _react2['default'].PropTypes.string,
    disabled: _react2['default'].PropTypes.bool,
    hasIcon: _react2['default'].PropTypes.bool,
    noSearchDataTips: _react2['default'].PropTypes.string
};

Select.defaultProps = {
    noSearchDataTips: '没有找到相关数据',
    hasIcon: false,
    type: "single",
    selected: [],
    width: 200,
    maxHeight: 180,
    openSearch: false
};

exports['default'] = Select;
module.exports = exports['default'];